﻿Type=Class
Version=2.2
B4J=true
@EndOfDesignText@
' File: sendmail.bas
' Module Type: WebSocket class
' Purpose: Start the senmail page to then executed selected functions
' Changed: See readme.txt
' 
Sub Class_Globals
	Private ws As WebSocket
	Private JSONfile As String = "webappsendmail.json"
	
	Private dlgmessage As JQueryElement
	Private fieldMessage As JQueryElement

	Private btnSend As JQueryElement	
	Private fieldTo As JQueryElement
	Private fieldSubject As JQueryElement
	Private fieldBody As JQueryElement

	Private dlgconfiguration As JQueryElement
	Private fieldmailserver As JQueryElement
	Private fieldport As JQueryElement
	Private fieldusername As JQueryElement
	Private fieldpassword As JQueryElement

	Private lblTitle As JQueryElement
	Private lblFooter As JQueryElement

	Private smtpEMail As SMTP
	Private gmapSettings As Map
End Sub

Public Sub Initialize
	
End Sub

' User connects to the server by opening up index.html.
Private Sub WebSocket_Connected (WebSocket1 As WebSocket)
	Main.AppLog("WebSocket_Connected :: Start")
	'
	' Init the global settings map
	gmapSettings.Initialize
	' Assigng the websocket
	ws = WebSocket1
	' Read the config into global map gmapSettings
	readConfig
	fieldTo.SetVal(gmapSettings.GetDefault("lastto", "name@address.com"))
	' Update various labels
	lblTitle.SetText(Main.CAPPTITLE)
	lblFooter.SetText(Main.CAPPCOPYRIGHT)
	'
	Main.AppLog("WebSocket_Connected :: End")
End Sub

' Send the email
Sub btnSend_Click(Params As Map)
	If checkMessageFields = True Then 
		SendEmail
	End If
End Sub

' Show the configuration dialog populated with latest config values
Sub btnConfiguration_Click(Params As Map)
	Main.AppLog("btnConfiguration :: Start")
	' Read the config to get the latest values
	readConfig
	' Update the configuration dialog fields from the global map gmapSettings
	fieldmailserver.SetVal(gmapSettings.Get("mailserver"))
	fieldport.SetVal(gmapSettings.Get("port"))
	fieldusername.SetVal(gmapSettings.Get("username"))
	fieldpassword.SetVal(gmapSettings.Get("password"))
	' Open the configuration dialog
	ws.RunFunction("OpenDialog", Array As String(dlgconfiguration.Id))
	Main.AppLog("btnConfiguration :: End")
End Sub

' Configuration dialog Button OK clicked
Sub btnconfigurationok_Event(Params As Map)
	Main.AppLog("btnconfigurationok :: Start")
	'TODO: Add checkConfigurationFields befor saving
	'
	gmapSettings.Put("mailserver", fieldmailserver.GetVal.Value)
	gmapSettings.Put("port", fieldport.GetVal.Value)
	gmapSettings.Put("username", fieldusername.GetVal.Value)
	gmapSettings.Put("password", fieldpassword.GetVal.Value)
	writeConfig
	'
	Main.AppLog("btnconfigurationok :: End")
End Sub

' Show information about this app
Sub btnAbout_Click(Params As Map)
	showMessage(Main.CAPPTITLE & CRLF & Main.CAPPVERSION & CRLF & Main.CAPPCOPYRIGHT)
	' ws.Alert(Main.CAPPTITLE & CRLF & Main.CAPPVERSION & CRLF & Main.CAPPCOPYRIGHT)
End Sub

Sub showMessage(msg As String)
	fieldMessage.SetVal(msg)
	ws.RunFunction("OpenDialog", Array As String(dlgmessage.Id))
End Sub

Sub SendEmail
	Main.AppLog("SendEmail :: Start")
	Dim event As String	= "SMTP"
	Main.AppLog("> SMPTP Initialize")
	smtpEMail.Initialize(gmapSettings.Get("mailserver"), gmapSettings.Get("port"), gmapSettings.Get("username"), gmapSettings.Get("password"), event)
	smtpEMail.UseSSL = False
	smtpEMail.To.Add(fieldTo.GetVal.Value)
	smtpEMail.Subject = fieldSubject.GetVal.Value
	smtpEMail.Body = fieldBody.GetVal.Value
	Main.AppLog("> SMPTP Send")
	gmapSettings.Put("lastto", fieldTo.GetVal.Value)
	smtpEMail.Send
	lblFooter.SetText("Mail has been sent.")
	Main.AppLog("SendEmail :: End")
End Sub

Sub SMTP_MessageSent(Success As Boolean)
	Main.AppLog("SMTP_MessageSent :: Start - Success:" & Success)
	Dim msg As String = DateTime.Time(DateTime.Now) & " :: Mail sent "
	If Success = False Then
		msg = msg & "error."
  	Else
      	msg = msg & "successful."
  	End If
	Main.AppLog(" > " & msg)
	' THIS DOES NOT WORK STRAIGHT - The label is updated after f.e. button About was clicked
	lblFooter.SetText(msg)
	' showMessage(msg)
	Main.AppLog("SMTP_MessageSent :: End - " & ws.Open)
End Sub

' Check the message fields To and Subject befor sending email
Sub checkMessageFields As Boolean
	Dim result As Boolean = True
	' Check email address in field "To"
	Dim isValid As Boolean
	isValid = Regex.IsMatch("[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?", fieldTo.GetVal.Value)
	If isValid = False Then
		ws.Alert("Error: Invaled EMail entered: " & CRLF & fieldTo.GetVal.Value & CRLF)
		result = False
	End If
	Dim s As String = fieldSubject.GetVal.Value
	If s.Length = 0 Then
		ws.Alert("Error: No subject defined!")
		result = False
	End If
	Return result
End Sub

' Read the JSON file structure in the global map
Sub readConfig
	Main.AppLog("ReadConfig :: Start")
	Dim JSON As JSONParser
	JSON.Initialize(File.ReadString(File.DirApp, JSONfile))
	Dim l As List
	l = JSON.NextArray
	gmapSettings = l.Get(0)
	Main.AppLog("> Mailserver:" & gmapSettings.Get("mailserver"))
	Main.AppLog("ReadConfig :: End")
End Sub

' Write the updated structure in the global map
Sub writeConfig
	Main.AppLog("WriteConfig :: Start")
	Dim JSONGenerator As JSONGenerator
	Dim Data As List
    Data.Initialize
    Data.Add(gmapSettings) 
	JSONGenerator.Initialize2(Data)
	File.WriteString(File.DirApp, JSONfile, JSONGenerator.ToPrettyString(2))
	Main.AppLog("WriteConfig :: End")
End Sub

